%parametri e dati
M=2;
betadB=[4:1:10, 10.25:0.25:11]; %Eb/N0 in dB
bits=1e6; %per la simulazione
numerominimoerrori=100;
%memorizzazione siumulazione
ln=length(betadB);
bitsimulati=zeros(1,ln);
errori=zeros(1,ln);
completato=zeros(1,ln);
%analisi teorica
beta=10.^(betadB/10); %Eb/N0
gamma=beta*log2(M); %Eav/N0
sigma=(1./(2*gamma)).^0.5; %Eav=1
pet=1/2*erfc((gamma).^0.5); %binaria antipodale
%simulazione
while prod(completato)==0
    for i=1:length(gamma)
        if completato(i)==0
            noise=sigma(i)*randn(1,bits);
            errori(i)=errori(i)+sum(noise>1); %trasmessi tutti "0"
            bitsimulati(i)=bitsimulati(i)+bits;
            if errori(i)>=numerominimoerrori
                completato(i)=1;
            end
        end
    end
    errori
    %input('premi un tasto');
end
pes=errori./bitsimulati;
%grafici
semilogy(betadB,pet,'k:o');
hold on
semilogy(betadB,pes,'r*');
xlabel('E_b/N_0 [dB]');
ylabel('B.E.R.');
title('Modulazione binaria antipodale');
