clear
%parametri e dati
M=16;
betadB=[4:1:20]; %Eb/N0 in dB
symbols=1e6; %per la simulazione
%analisi teorica
rth=(3/(M^2-1))^.5;
beta=10.^(betadB/10); %Eb/N0
gamma=beta*log2(M); %Eav/N0
pet=(M-1)/M*erfc((3*gamma/(M^2-1)).^0.5); %MASK
%simulazione
for i=1:length(gamma)
    sigma=(1/(2*gamma(i)))^0.5; %Eav=1
    noise=sigma*randn(1,symbols);
    pes(i)=sum(abs(noise)>rth)/symbols; %trasmessi tutti "0"
end
%grafici
semilogy(betadB,pet,'k:o');
hold on
semilogy(betadB,pes,'r*');
xlabel('E_b/N_0 [dB]');
ylabel('B.E.R.');
str=sprintf('Modulazione %d-ASK',M);
title(str);
